'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Node = function Node(value) {
  var next = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var previous = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  _classCallCheck(this, Node);

  this.value = value;
  this.next = next;
  this.previous = previous;
};

var List =
/*#__PURE__*/
function () {
  function List() {
    _classCallCheck(this, List);

    this.first = null;
    this.end = null;
  }

  _createClass(List, [{
    key: "add",

    /**
    * Adds a value to the end of the linked list
    * @param {*}
    */
    value: function add(value) {
      var n = new Node(value);

      if (this.isEmpty()) {
        this.first = n;
        this.end = this.first;
      } else {
        this.end.next = n;
        n.previous = this.end;
        this.end = n;
      }
    }
    /**
     * Adds a value at first position of list
     * @param {*} value
     */

  }, {
    key: "addFirst",
    value: function addFirst(value) {
      var n = new Node(value, this.first);

      if (!this.isEmpty()) {
        this.first.previous = n;
      }

      this.first = n;

      if (this.end === null) {
        this.end = this.first;
      }
    }
    /**
    * Adds a value into a specified position in the list
    * @param {*} value
    * @param {Number} position
    */

  }, {
    key: "addAtPosition",
    value: function addAtPosition(value, position) {
      var index = 1;
      var current = this.first;
      var n = new Node(value);

      if (position === 0) {
        this.addFirst(value);
        return;
      }

      while (current !== null) {
        if (index < position) {
          current = current.next;
          index++;
        } else if (index === position) {
          var tmp = current.next;
          current.next = n;
          n.previous = current;
          n.next = tmp;
          tmp.previous = n;

          if (n.previous === this.end) {
            this.end = n;
          }

          break;
        }
      }

      if (index !== position && position !== 0 || current === null) {
        throw new Error('Unable to add at position ' + position + ', list is of length ' + (index === 1 ? 0 : index));
      }
    }
    /**
     * Search for a value in the list
     * @param  {*} value
     * @return {Node}
     */

  }, {
    key: "search",
    value: function search(value) {
      var current = this.first;

      while (current !== null) {
        if (current.value === value) {
          return current;
        }

        current = current.next;
      }

      return false;
    }
    /**
     * Delete a value from the list
     * @param  {*} value
     * @return {Boolean}
     */

  }, {
    key: "delete",
    value: function _delete(value) {
      var node = this.search(value);

      if (node) {
        if (!node.previous) {
          this.first = node.next;
          this.first.previous = null;
        } else {
          var tmp = node.next;
          var tmp2 = node.previous;
          node.previous.next = tmp;

          if (tmp) {
            tmp.previous = tmp2;
          }

          if (this.end === node.previous) {
            this.end = node;
          }
        }

        return true;
      }

      return false;
    }
    /**
     * Reverse the linked list
     */

  }, {
    key: "reverse",
    value: function reverse() {
      if (!this.isEmpty()) {
        var current = this.first;

        while (current !== null) {
          var _tmp = current.next;
          current.next = current.previous;
          current.previous = _tmp;
          current = _tmp;
        }

        var tmp = this.end;
        this.end = this.first;
        this.first = tmp;
      }
    }
    /**
    * @return {Boolean}
    */

  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return this.first === null;
    }
  }, {
    key: "values",
    get: function get() {
      var values = '';

      if (!this.isEmpty()) {
        var current = this.first;

        while (current !== null) {
          values += JSON.stringify(current.value) + ',';
          current = current.next;
        }

        values = values.slice(0, -1);
      }

      return values;
    }
  }]);

  return List;
}();

exports["default"] = List;
;